//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string note1            = "Stochastic settings";
extern string note2            = "default = Stoch(30,10,10)";
extern int    KPeriod          =  14;
extern int    DPeriod          =  7;
extern int    Slowing          =  5;
extern string note3            = "0=sma, 1=ema, 2=smma, 3=lwma";
extern int    MAMethod         =  0;
extern string note4            = "0=high/low, 1=close/close";
extern int    PriceField       =  1;
extern string note15           = "---------------------------------- Try";
extern string note16           = "GBPJPY M15 chart Stoch(30,10,10)";
extern double levelOb          = 75;
extern double levelOs          = 25;
extern string note             = "turn on Alert = true";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

//
//
//
//
//

double UpH[];
double DnH[]; 
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);   
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);   
   SetIndexBuffer(2,trend1);
   SetIndexBuffer(3,trend2);
   return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double stoch = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MAMethod,PriceField,0,i);
      trend1[i] = 0;
             if (stoch>levelOb) trend1[i] = 1;
             if (stoch<levelOs) trend1[i] =-1;
             
             //
             //
             //
             //
             //
             
             trend2[i] = trend2[i+1];
             UpH[i] = EMPTY_VALUE;
             DnH[i] = EMPTY_VALUE;
               if (trend1[i] == 0 && trend1[i+1] ==-1) trend2[i] = 1;
               if (trend1[i] == 0 && trend1[i+1] == 1) trend2[i] =-1;
               if (trend2[i] == 1) UpH[i] = 1;
               if (trend2[i] ==-1) DnH[i] = 1;
             
             
       }
       
       //
       //
       //
       //
       //
          
       if (alertsOn)
       {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(whichBar,"Oversold");
            if (trend2[whichBar] == -1) doAlert(whichBar,"Overbought");
         }           
   }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Stoch Crossing ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Stoch Crossing "),message);
             if (alertsNotify)    SendNotification(StringConcatenate(Symbol(), Period() ," Stoch Crossing " +" "+message));
             if (alertsSound)   PlaySound(soundFile);
   }
}
   
   